#ifdef LOCAL
#include "../../testlib.h"
#else
#include "testlib.h"
#endif

using namespace std;

int MAX_N = 100'000, MAX_M = 100'000;
long long MAX_VAL = (1LL << 15);

template<class T>
T opt_or_default(const string& s, T d_val) {
    return has_opt(s) ? opt<T>(s) : d_val;
}

int main(int argc, char *argv[]) {
    registerGen(argc, argv, 1);
    int n = opt_or_default("n", MAX_N);
    int m = opt_or_default("m", MAX_M);
    long long v_lim = opt_or_default("a", MAX_VAL);
    cout << n << " " << m << "\n";
    for (int i = 0; i < n; i++) {
        cout << rnd.next(v_lim);
        if (i + 1 < n) {
            cout << " ";
        }
    }
    cout << "\n";
    int w_len = opt_or_default("w_len", 0);
    int freq1 = opt_or_default("f1", 1000),
            freq2 = opt_or_default("f2", 1000),
            freq3 = opt_or_default("f3", 1000);
    for (int i = 0; i < m; i++) {
        int val = rnd.next(freq1 + freq2 + freq3);
        int len = rnd.wnext(n, w_len);
        int l = rnd.next(1, n - len);
        if (val < freq1) {
            cout << 1 << " " << l << " " << l + len << "\n";
        } else if (val < freq1 + freq2) {
            long long int x = rnd.next(v_lim);
            cout << 2 << " " << l << " " << l + len << " " << x << "\n";
        } else {
            long long int x = rnd.next(v_lim);
            string cmd = rnd.next("^|&|\\|");
            cout << 3 << " " << l << " " << l + len << " " << x << " " << cmd << "\n";
        }
    }
}